import midiio
import time

for dev in midiio.get_input_devices():
		print "input", dev.id
		print "    Manufacturer ID   %d" % dev.manufacturer_id
		print "    Product ID        %d" % dev.product_id
		print "    Driver Version    %d.%d" % dev.driver_version
		print "    Product name      %s" % dev.name
		print "    Supported         %s" % `dev.supported`

for dev in midiio.get_output_devices():
		print "output", dev.id
		print "    Manufacturer ID   %d" % dev.manufacturer_id
		print "    Product ID        %d" % dev.product_id
		print "    Driver Version    %d.%d" % dev.driver_version
		print "    Product name      %s" % dev.name
		print "    Supported         %s" % `dev.supported`
		print "    Technology        %d" % dev.technology
		print "    Voices            %d" % dev.voices
		print "    Channels          %s" % `dev.channels`

print "Testing output..."
if midiio.count_output_devices() == 0:
	print "\tno output devices to test!"
chord = [60, 64, 67, 72]
for dev in midiio.get_output_devices():
    print "  playing C major chord on", dev.name
    for note in chord: dev.write([0x90, note, 127])
    time.sleep(0.5)
    for note in chord: dev.write([0x80, note, 0])

print "Testing input..."
if midiio.count_input_devices() == 0:
	print "\tno input devices to test!"
timeout = 2000
npackets = 4
for dev in midiio.get_input_devices():
    print "  reading", npackets, "command packets or timeouts from", dev.name
    try:
      for _ in xrange(npackets):
	try:
	    when,mididata = dev.read(timeout)
	    print ("  %8d:" % when),
	    di = 0
	    while di < len(mididata):
		    d = mididata[di]
		    di = di + 1
		    if (d < 0x80):
			    print ("%02x" % d),
		    elif (d & 0xf0) == 0x80:
			    print ("NOTE-OFF[%d]" % ((d&0x0f) + 1)),
		    elif (d & 0xf0) == 0x90:
			    print ("NOTE-ON [%d]" % ((d&0x0f) + 1)),
		    elif (d & 0xf0) == 0xA0:
			    print ("AFTERTOUCH[%d]" % ((d&0x0f) + 1)),
		    elif (d & 0xf0) == 0xB0:
			    print ("CONTROL[%d]" % ((d&0x0f) + 1)),
		    elif (d & 0xf0) == 0xC0:
		      if mididata[di] >= 120:
			c,v = mididata[di],mididata[di+1]; di = di + 2
			if   c == 120: print "ALL-SOUND-OFF",
			elif c == 121: print "ALL-RESET",
			elif c == 122 and v == 0:
			    print "LOCAL-CONTROL-OFF",
			elif c == 122: print "LOCAL-CONTROL-ON",
			elif c == 123: print "ALL-NOTES-OFF",
			elif c == 124: print "OMNI-MODE-OFF",
			elif c == 125: print "OMNI-MODE-ON",
			elif c == 126: print "POLY-MODE-OFF",
			elif c == 127: print "POLY-MODE-ON",
		      else:
			    print ("PROGRAM[%d]" % ((d&0x0f) + 1)),
		    elif (d & 0xf0) == 0xD0:
			    print ("ALL-AFTERTOUCH[%d]" % ((d&0x0f) + 1)),
		    elif (d & 0xf0) == 0xE0:
			l,m = mididata[di],mididata[di+1]; di = di + 2
			print ("PITCHWHEEL[%d] %d" % ((d&0x0f) + 1,
				((m << 7) | l)-0x2000)),
		    elif d == 0xf0:
			    print "SYSEX",
			    while di < len(mididata):
				d = mididata[di]; di = di + 1
				if d == 0xf7: break
				print ("%02x" % d),
			    print "ENDEX",
		    elif d == 0xf2:
			l,m = mididata[di],mididata[di+1]; di = di + 2
			print ("SONGPOS %d" % ((m << 7) | l)),
		    elif d == 0xf3:
			print "SONGSEL",
		    elif d == 0xf6:
			print "TUNE-REQUEST",
		    elif d == 0xf7:
			print "ENDEX",
		    else:
			print ("UNDEF-%02x" % d),
	    print ";"
	except midiio.Timeout:
	    print "  (timeout after %d msec)" % timeout
    finally:
	dev.close()

print "tests succeeded"
